<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cancel_Pending_Supplier_Change_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains reference to Supplier with a pending Supplier Change to cancel.
 * @subpackage Structs
 */
class Cancel_Pending_Supplier_Change_RequestType extends AbstractStructBase
{
    /**
     * The Supplier_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier with a pending Supplier Change to cancel.
     * @var \StructType\SupplierObjectType
     */
    public $Supplier_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Cancel_Pending_Supplier_Change_RequestType
     * @uses Cancel_Pending_Supplier_Change_RequestType::setSupplier_Reference()
     * @uses Cancel_Pending_Supplier_Change_RequestType::setVersion()
     * @param \StructType\SupplierObjectType $supplier_Reference
     * @param string $version
     */
    public function __construct(\StructType\SupplierObjectType $supplier_Reference = null, $version = null)
    {
        $this
            ->setSupplier_Reference($supplier_Reference)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Reference value
     * @return \StructType\SupplierObjectType|null
     */
    public function getSupplier_Reference()
    {
        return $this->Supplier_Reference;
    }
    /**
     * Set Supplier_Reference value
     * @param \StructType\SupplierObjectType $supplier_Reference
     * @return \StructType\Cancel_Pending_Supplier_Change_RequestType
     */
    public function setSupplier_Reference(\StructType\SupplierObjectType $supplier_Reference = null)
    {
        $this->Supplier_Reference = $supplier_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Cancel_Pending_Supplier_Change_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
