<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cancel_Receipt_Adjustment_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Cancel Receipt Adjustment Request
 * @subpackage Structs
 */
class Cancel_Receipt_Adjustment_RequestType extends AbstractStructBase
{
    /**
     * The Receipt_Adjustment_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Receipt Adjustment
     * @var \StructType\Receipt_AdjustmentObjectType
     */
    public $Receipt_Adjustment_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Cancel_Receipt_Adjustment_RequestType
     * @uses Cancel_Receipt_Adjustment_RequestType::setReceipt_Adjustment_Reference()
     * @uses Cancel_Receipt_Adjustment_RequestType::setVersion()
     * @param \StructType\Receipt_AdjustmentObjectType $receipt_Adjustment_Reference
     * @param string $version
     */
    public function __construct(\StructType\Receipt_AdjustmentObjectType $receipt_Adjustment_Reference = null, $version = null)
    {
        $this
            ->setReceipt_Adjustment_Reference($receipt_Adjustment_Reference)
            ->setVersion($version);
    }
    /**
     * Get Receipt_Adjustment_Reference value
     * @return \StructType\Receipt_AdjustmentObjectType|null
     */
    public function getReceipt_Adjustment_Reference()
    {
        return $this->Receipt_Adjustment_Reference;
    }
    /**
     * Set Receipt_Adjustment_Reference value
     * @param \StructType\Receipt_AdjustmentObjectType $receipt_Adjustment_Reference
     * @return \StructType\Cancel_Receipt_Adjustment_RequestType
     */
    public function setReceipt_Adjustment_Reference(\StructType\Receipt_AdjustmentObjectType $receipt_Adjustment_Reference = null)
    {
        $this->Receipt_Adjustment_Reference = $receipt_Adjustment_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Cancel_Receipt_Adjustment_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
