<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Change_Prepaid_Amortization_Type_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing supplier invoice reference for change prepaid amortization type and its associated data.
 * @subpackage Structs
 */
class Change_Prepaid_Amortization_Type_RequestType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to supplier invoice for change prepaid amortization type
     * @var \StructType\Supplier_InvoiceObjectType
     */
    public $Supplier_Invoice_Reference;
    /**
     * The Change_Prepaid_Amortization_Type_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Change_Prepaid_Amortization_Type_DataType
     */
    public $Change_Prepaid_Amortization_Type_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Change_Prepaid_Amortization_Type_RequestType
     * @uses Change_Prepaid_Amortization_Type_RequestType::setSupplier_Invoice_Reference()
     * @uses Change_Prepaid_Amortization_Type_RequestType::setChange_Prepaid_Amortization_Type_Data()
     * @uses Change_Prepaid_Amortization_Type_RequestType::setVersion()
     * @param \StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference
     * @param \StructType\Change_Prepaid_Amortization_Type_DataType $change_Prepaid_Amortization_Type_Data
     * @param string $version
     */
    public function __construct(\StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference = null, \StructType\Change_Prepaid_Amortization_Type_DataType $change_Prepaid_Amortization_Type_Data = null, $version = null)
    {
        $this
            ->setSupplier_Invoice_Reference($supplier_Invoice_Reference)
            ->setChange_Prepaid_Amortization_Type_Data($change_Prepaid_Amortization_Type_Data)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Invoice_Reference value
     * @return \StructType\Supplier_InvoiceObjectType|null
     */
    public function getSupplier_Invoice_Reference()
    {
        return $this->Supplier_Invoice_Reference;
    }
    /**
     * Set Supplier_Invoice_Reference value
     * @param \StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference
     * @return \StructType\Change_Prepaid_Amortization_Type_RequestType
     */
    public function setSupplier_Invoice_Reference(\StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference = null)
    {
        $this->Supplier_Invoice_Reference = $supplier_Invoice_Reference;
        return $this;
    }
    /**
     * Get Change_Prepaid_Amortization_Type_Data value
     * @return \StructType\Change_Prepaid_Amortization_Type_DataType|null
     */
    public function getChange_Prepaid_Amortization_Type_Data()
    {
        return $this->Change_Prepaid_Amortization_Type_Data;
    }
    /**
     * Set Change_Prepaid_Amortization_Type_Data value
     * @param \StructType\Change_Prepaid_Amortization_Type_DataType $change_Prepaid_Amortization_Type_Data
     * @return \StructType\Change_Prepaid_Amortization_Type_RequestType
     */
    public function setChange_Prepaid_Amortization_Type_Data(\StructType\Change_Prepaid_Amortization_Type_DataType $change_Prepaid_Amortization_Type_Data = null)
    {
        $this->Change_Prepaid_Amortization_Type_Data = $change_Prepaid_Amortization_Type_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Change_Prepaid_Amortization_Type_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
