<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Expense_ItemType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper Element that includes Expense Item Instance and Data
 * @subpackage Structs
 */
class Expense_ItemType extends AbstractStructBase
{
    /**
     * The Expense_Item_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Expense Item
     * - minOccurs: 0
     * @var \StructType\Expense_ItemObjectType
     */
    public $Expense_Item_Reference;
    /**
     * The Expense_Item_Data
     * Meta information extracted from the WSDL
     * - documentation: Expense Item Data
     * - minOccurs: 0
     * @var \StructType\Expense_Item_DataType
     */
    public $Expense_Item_Data;
    /**
     * Constructor method for Expense_ItemType
     * @uses Expense_ItemType::setExpense_Item_Reference()
     * @uses Expense_ItemType::setExpense_Item_Data()
     * @param \StructType\Expense_ItemObjectType $expense_Item_Reference
     * @param \StructType\Expense_Item_DataType $expense_Item_Data
     */
    public function __construct(\StructType\Expense_ItemObjectType $expense_Item_Reference = null, \StructType\Expense_Item_DataType $expense_Item_Data = null)
    {
        $this
            ->setExpense_Item_Reference($expense_Item_Reference)
            ->setExpense_Item_Data($expense_Item_Data);
    }
    /**
     * Get Expense_Item_Reference value
     * @return \StructType\Expense_ItemObjectType|null
     */
    public function getExpense_Item_Reference()
    {
        return $this->Expense_Item_Reference;
    }
    /**
     * Set Expense_Item_Reference value
     * @param \StructType\Expense_ItemObjectType $expense_Item_Reference
     * @return \StructType\Expense_ItemType
     */
    public function setExpense_Item_Reference(\StructType\Expense_ItemObjectType $expense_Item_Reference = null)
    {
        $this->Expense_Item_Reference = $expense_Item_Reference;
        return $this;
    }
    /**
     * Get Expense_Item_Data value
     * @return \StructType\Expense_Item_DataType|null
     */
    public function getExpense_Item_Data()
    {
        return $this->Expense_Item_Data;
    }
    /**
     * Set Expense_Item_Data value
     * @param \StructType\Expense_Item_DataType $expense_Item_Data
     * @return \StructType\Expense_ItemType
     */
    public function setExpense_Item_Data(\StructType\Expense_Item_DataType $expense_Item_Data = null)
    {
        $this->Expense_Item_Data = $expense_Item_Data;
        return $this;
    }
}
