<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Expense_Rate_Table_Response_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper Element that includes Expense Policy Group Instance and Data
 * @subpackage Structs
 */
class Expense_Rate_Table_Response_DataType extends AbstractStructBase
{
    /**
     * The Expense_Rate_Table
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Expense_Rate_TableType[]
     */
    public $Expense_Rate_Table;
    /**
     * Constructor method for Expense_Rate_Table_Response_DataType
     * @uses Expense_Rate_Table_Response_DataType::setExpense_Rate_Table()
     * @param \StructType\Expense_Rate_TableType[] $expense_Rate_Table
     */
    public function __construct(array $expense_Rate_Table = array())
    {
        $this
            ->setExpense_Rate_Table($expense_Rate_Table);
    }
    /**
     * Get Expense_Rate_Table value
     * @return \StructType\Expense_Rate_TableType[]|null
     */
    public function getExpense_Rate_Table()
    {
        return $this->Expense_Rate_Table;
    }
    /**
     * This method is responsible for validating the values passed to the setExpense_Rate_Table method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExpense_Rate_Table method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExpense_Rate_TableForArrayConstraintsFromSetExpense_Rate_Table(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $expense_Rate_Table_Response_DataTypeExpense_Rate_TableItem) {
            // validation for constraint: itemType
            if (!$expense_Rate_Table_Response_DataTypeExpense_Rate_TableItem instanceof \StructType\Expense_Rate_TableType) {
                $invalidValues[] = is_object($expense_Rate_Table_Response_DataTypeExpense_Rate_TableItem) ? get_class($expense_Rate_Table_Response_DataTypeExpense_Rate_TableItem) : sprintf('%s(%s)', gettype($expense_Rate_Table_Response_DataTypeExpense_Rate_TableItem), var_export($expense_Rate_Table_Response_DataTypeExpense_Rate_TableItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Expense_Rate_Table property can only contain items of type \StructType\Expense_Rate_TableType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Expense_Rate_Table value
     * @throws \InvalidArgumentException
     * @param \StructType\Expense_Rate_TableType[] $expense_Rate_Table
     * @return \StructType\Expense_Rate_Table_Response_DataType
     */
    public function setExpense_Rate_Table(array $expense_Rate_Table = array())
    {
        // validation for constraint: array
        if ('' !== ($expense_Rate_TableArrayErrorMessage = self::validateExpense_Rate_TableForArrayConstraintsFromSetExpense_Rate_Table($expense_Rate_Table))) {
            throw new \InvalidArgumentException($expense_Rate_TableArrayErrorMessage, __LINE__);
        }
        $this->Expense_Rate_Table = $expense_Rate_Table;
        return $this;
    }
    /**
     * Add item to Expense_Rate_Table value
     * @throws \InvalidArgumentException
     * @param \StructType\Expense_Rate_TableType $item
     * @return \StructType\Expense_Rate_Table_Response_DataType
     */
    public function addToExpense_Rate_Table(\StructType\Expense_Rate_TableType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Expense_Rate_TableType) {
            throw new \InvalidArgumentException(sprintf('The Expense_Rate_Table property can only contain items of type \StructType\Expense_Rate_TableType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Expense_Rate_Table[] = $item;
        return $this;
    }
}
