<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Guest_Listing_File_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Reference element that contains a specific instance set containing the requested Guest Listing File.
 * @subpackage Structs
 */
class Guest_Listing_File_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Guest_Listing_File_Reference
     * Meta information extracted from the WSDL
     * - documentation: Instance set containing the Guest Listing File object.
     * - maxOccurs: unbounded
     * @var \StructType\Guest_Listing_FileObjectType[]
     */
    public $Guest_Listing_File_Reference;
    /**
     * Constructor method for Guest_Listing_File_Request_ReferencesType
     * @uses Guest_Listing_File_Request_ReferencesType::setGuest_Listing_File_Reference()
     * @param \StructType\Guest_Listing_FileObjectType[] $guest_Listing_File_Reference
     */
    public function __construct(array $guest_Listing_File_Reference = array())
    {
        $this
            ->setGuest_Listing_File_Reference($guest_Listing_File_Reference);
    }
    /**
     * Get Guest_Listing_File_Reference value
     * @return \StructType\Guest_Listing_FileObjectType[]|null
     */
    public function getGuest_Listing_File_Reference()
    {
        return $this->Guest_Listing_File_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setGuest_Listing_File_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuest_Listing_File_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuest_Listing_File_ReferenceForArrayConstraintsFromSetGuest_Listing_File_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $guest_Listing_File_Request_ReferencesTypeGuest_Listing_File_ReferenceItem) {
            // validation for constraint: itemType
            if (!$guest_Listing_File_Request_ReferencesTypeGuest_Listing_File_ReferenceItem instanceof \StructType\Guest_Listing_FileObjectType) {
                $invalidValues[] = is_object($guest_Listing_File_Request_ReferencesTypeGuest_Listing_File_ReferenceItem) ? get_class($guest_Listing_File_Request_ReferencesTypeGuest_Listing_File_ReferenceItem) : sprintf('%s(%s)', gettype($guest_Listing_File_Request_ReferencesTypeGuest_Listing_File_ReferenceItem), var_export($guest_Listing_File_Request_ReferencesTypeGuest_Listing_File_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Guest_Listing_File_Reference property can only contain items of type \StructType\Guest_Listing_FileObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Guest_Listing_File_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Guest_Listing_FileObjectType[] $guest_Listing_File_Reference
     * @return \StructType\Guest_Listing_File_Request_ReferencesType
     */
    public function setGuest_Listing_File_Reference(array $guest_Listing_File_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($guest_Listing_File_ReferenceArrayErrorMessage = self::validateGuest_Listing_File_ReferenceForArrayConstraintsFromSetGuest_Listing_File_Reference($guest_Listing_File_Reference))) {
            throw new \InvalidArgumentException($guest_Listing_File_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Guest_Listing_File_Reference = $guest_Listing_File_Reference;
        return $this;
    }
    /**
     * Add item to Guest_Listing_File_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Guest_Listing_FileObjectType $item
     * @return \StructType\Guest_Listing_File_Request_ReferencesType
     */
    public function addToGuest_Listing_File_Reference(\StructType\Guest_Listing_FileObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Guest_Listing_FileObjectType) {
            throw new \InvalidArgumentException(sprintf('The Guest_Listing_File_Reference property can only contain items of type \StructType\Guest_Listing_FileObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Guest_Listing_File_Reference[] = $item;
        return $this;
    }
}
