<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Budget_Template_Response_GroupType StructType
 * Meta information extracted from the WSDL
 * - documentation: Parameters that let you control what data is returned in the response.
 * @subpackage Structs
 */
class Project_Budget_Template_Response_GroupType extends AbstractStructBase
{
    /**
     * The Include_Reference
     * Meta information extracted from the WSDL
     * - documentation: Controls whether to return the Project Budget Template Reference in the response.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Reference;
    /**
     * The Include_Project_Budget_Template_Data
     * Meta information extracted from the WSDL
     * - documentation: Controls whether to return the Project Budget Template Data in the response.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Project_Budget_Template_Data;
    /**
     * Constructor method for Project_Budget_Template_Response_GroupType
     * @uses Project_Budget_Template_Response_GroupType::setInclude_Reference()
     * @uses Project_Budget_Template_Response_GroupType::setInclude_Project_Budget_Template_Data()
     * @param bool $include_Reference
     * @param bool $include_Project_Budget_Template_Data
     */
    public function __construct($include_Reference = null, $include_Project_Budget_Template_Data = null)
    {
        $this
            ->setInclude_Reference($include_Reference)
            ->setInclude_Project_Budget_Template_Data($include_Project_Budget_Template_Data);
    }
    /**
     * Get Include_Reference value
     * @return bool|null
     */
    public function getInclude_Reference()
    {
        return $this->Include_Reference;
    }
    /**
     * Set Include_Reference value
     * @param bool $include_Reference
     * @return \StructType\Project_Budget_Template_Response_GroupType
     */
    public function setInclude_Reference($include_Reference = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Reference) && !is_bool($include_Reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($include_Reference, true), gettype($include_Reference)), __LINE__);
        }
        $this->Include_Reference = $include_Reference;
        return $this;
    }
    /**
     * Get Include_Project_Budget_Template_Data value
     * @return bool|null
     */
    public function getInclude_Project_Budget_Template_Data()
    {
        return $this->Include_Project_Budget_Template_Data;
    }
    /**
     * Set Include_Project_Budget_Template_Data value
     * @param bool $include_Project_Budget_Template_Data
     * @return \StructType\Project_Budget_Template_Response_GroupType
     */
    public function setInclude_Project_Budget_Template_Data($include_Project_Budget_Template_Data = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Project_Budget_Template_Data) && !is_bool($include_Project_Budget_Template_Data)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($include_Project_Budget_Template_Data, true), gettype($include_Project_Budget_Template_Data)), __LINE__);
        }
        $this->Include_Project_Budget_Template_Data = $include_Project_Budget_Template_Data;
        return $this;
    }
}
