<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Task_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Get Project Task Request References
 * @subpackage Structs
 */
class Project_Task_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Project_Task_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Task Request Reference
     * - maxOccurs: unbounded
     * @var \StructType\Project_TaskObjectType[]
     */
    public $Project_Task_Reference;
    /**
     * Constructor method for Project_Task_Request_ReferencesType
     * @uses Project_Task_Request_ReferencesType::setProject_Task_Reference()
     * @param \StructType\Project_TaskObjectType[] $project_Task_Reference
     */
    public function __construct(array $project_Task_Reference = array())
    {
        $this
            ->setProject_Task_Reference($project_Task_Reference);
    }
    /**
     * Get Project_Task_Reference value
     * @return \StructType\Project_TaskObjectType[]|null
     */
    public function getProject_Task_Reference()
    {
        return $this->Project_Task_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Task_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Task_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_Task_ReferenceForArrayConstraintsFromSetProject_Task_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Task_Request_ReferencesTypeProject_Task_ReferenceItem) {
            // validation for constraint: itemType
            if (!$project_Task_Request_ReferencesTypeProject_Task_ReferenceItem instanceof \StructType\Project_TaskObjectType) {
                $invalidValues[] = is_object($project_Task_Request_ReferencesTypeProject_Task_ReferenceItem) ? get_class($project_Task_Request_ReferencesTypeProject_Task_ReferenceItem) : sprintf('%s(%s)', gettype($project_Task_Request_ReferencesTypeProject_Task_ReferenceItem), var_export($project_Task_Request_ReferencesTypeProject_Task_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Task_Reference property can only contain items of type \StructType\Project_TaskObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Task_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_TaskObjectType[] $project_Task_Reference
     * @return \StructType\Project_Task_Request_ReferencesType
     */
    public function setProject_Task_Reference(array $project_Task_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($project_Task_ReferenceArrayErrorMessage = self::validateProject_Task_ReferenceForArrayConstraintsFromSetProject_Task_Reference($project_Task_Reference))) {
            throw new \InvalidArgumentException($project_Task_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Project_Task_Reference = $project_Task_Reference;
        return $this;
    }
    /**
     * Add item to Project_Task_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_TaskObjectType $item
     * @return \StructType\Project_Task_Request_ReferencesType
     */
    public function addToProject_Task_Reference(\StructType\Project_TaskObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_TaskObjectType) {
            throw new \InvalidArgumentException(sprintf('The Project_Task_Reference property can only contain items of type \StructType\Project_TaskObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Task_Reference[] = $item;
        return $this;
    }
}
