<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Purchase_Order_Schedule_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Get Purchase Order Schedule Request References
 * @subpackage Structs
 */
class Purchase_Order_Schedule_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Purchase_Order_Schedule_Reference
     * Meta information extracted from the WSDL
     * - documentation: Purchase Order Schedule References.
     * - maxOccurs: unbounded
     * @var \StructType\Purchase_Order_ScheduleObjectType[]
     */
    public $Purchase_Order_Schedule_Reference;
    /**
     * Constructor method for Purchase_Order_Schedule_Request_ReferencesType
     * @uses Purchase_Order_Schedule_Request_ReferencesType::setPurchase_Order_Schedule_Reference()
     * @param \StructType\Purchase_Order_ScheduleObjectType[] $purchase_Order_Schedule_Reference
     */
    public function __construct(array $purchase_Order_Schedule_Reference = array())
    {
        $this
            ->setPurchase_Order_Schedule_Reference($purchase_Order_Schedule_Reference);
    }
    /**
     * Get Purchase_Order_Schedule_Reference value
     * @return \StructType\Purchase_Order_ScheduleObjectType[]|null
     */
    public function getPurchase_Order_Schedule_Reference()
    {
        return $this->Purchase_Order_Schedule_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setPurchase_Order_Schedule_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPurchase_Order_Schedule_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePurchase_Order_Schedule_ReferenceForArrayConstraintsFromSetPurchase_Order_Schedule_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $purchase_Order_Schedule_Request_ReferencesTypePurchase_Order_Schedule_ReferenceItem) {
            // validation for constraint: itemType
            if (!$purchase_Order_Schedule_Request_ReferencesTypePurchase_Order_Schedule_ReferenceItem instanceof \StructType\Purchase_Order_ScheduleObjectType) {
                $invalidValues[] = is_object($purchase_Order_Schedule_Request_ReferencesTypePurchase_Order_Schedule_ReferenceItem) ? get_class($purchase_Order_Schedule_Request_ReferencesTypePurchase_Order_Schedule_ReferenceItem) : sprintf('%s(%s)', gettype($purchase_Order_Schedule_Request_ReferencesTypePurchase_Order_Schedule_ReferenceItem), var_export($purchase_Order_Schedule_Request_ReferencesTypePurchase_Order_Schedule_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Purchase_Order_Schedule_Reference property can only contain items of type \StructType\Purchase_Order_ScheduleObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Purchase_Order_Schedule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Purchase_Order_ScheduleObjectType[] $purchase_Order_Schedule_Reference
     * @return \StructType\Purchase_Order_Schedule_Request_ReferencesType
     */
    public function setPurchase_Order_Schedule_Reference(array $purchase_Order_Schedule_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($purchase_Order_Schedule_ReferenceArrayErrorMessage = self::validatePurchase_Order_Schedule_ReferenceForArrayConstraintsFromSetPurchase_Order_Schedule_Reference($purchase_Order_Schedule_Reference))) {
            throw new \InvalidArgumentException($purchase_Order_Schedule_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Purchase_Order_Schedule_Reference = $purchase_Order_Schedule_Reference;
        return $this;
    }
    /**
     * Add item to Purchase_Order_Schedule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Purchase_Order_ScheduleObjectType $item
     * @return \StructType\Purchase_Order_Schedule_Request_ReferencesType
     */
    public function addToPurchase_Order_Schedule_Reference(\StructType\Purchase_Order_ScheduleObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Purchase_Order_ScheduleObjectType) {
            throw new \InvalidArgumentException(sprintf('The Purchase_Order_Schedule_Reference property can only contain items of type \StructType\Purchase_Order_ScheduleObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Purchase_Order_Schedule_Reference[] = $item;
        return $this;
    }
}
