<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Expense_Rate_Table_Rule_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: This element is the top-level response element for all "Put" Expense Rate Table Rule operations.
 * @subpackage Structs
 */
class Put_Expense_Rate_Table_Rule_ResponseType extends AbstractStructBase
{
    /**
     * The Expense_Rate_Table_Rule_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the Expense Rate Table Rule that was added or updated in the operation.
     * - minOccurs: 0
     * @var \StructType\Condition_RuleObjectType
     */
    public $Expense_Rate_Table_Rule_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Expense_Rate_Table_Rule_ResponseType
     * @uses Put_Expense_Rate_Table_Rule_ResponseType::setExpense_Rate_Table_Rule_Reference()
     * @uses Put_Expense_Rate_Table_Rule_ResponseType::setVersion()
     * @param \StructType\Condition_RuleObjectType $expense_Rate_Table_Rule_Reference
     * @param string $version
     */
    public function __construct(\StructType\Condition_RuleObjectType $expense_Rate_Table_Rule_Reference = null, $version = null)
    {
        $this
            ->setExpense_Rate_Table_Rule_Reference($expense_Rate_Table_Rule_Reference)
            ->setVersion($version);
    }
    /**
     * Get Expense_Rate_Table_Rule_Reference value
     * @return \StructType\Condition_RuleObjectType|null
     */
    public function getExpense_Rate_Table_Rule_Reference()
    {
        return $this->Expense_Rate_Table_Rule_Reference;
    }
    /**
     * Set Expense_Rate_Table_Rule_Reference value
     * @param \StructType\Condition_RuleObjectType $expense_Rate_Table_Rule_Reference
     * @return \StructType\Put_Expense_Rate_Table_Rule_ResponseType
     */
    public function setExpense_Rate_Table_Rule_Reference(\StructType\Condition_RuleObjectType $expense_Rate_Table_Rule_Reference = null)
    {
        $this->Expense_Rate_Table_Rule_Reference = $expense_Rate_Table_Rule_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Expense_Rate_Table_Rule_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
