<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_OCR_Supplier_Invoice_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing OCR Supplier Invoice Reference
 * @subpackage Structs
 */
class Put_OCR_Supplier_Invoice_ResponseType extends AbstractStructBase
{
    /**
     * The OCR_Supplier_Invoice_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing OCR Supplier Invoice
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $OCR_Supplier_Invoice_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_OCR_Supplier_Invoice_ResponseType
     * @uses Put_OCR_Supplier_Invoice_ResponseType::setOCR_Supplier_Invoice_Reference()
     * @uses Put_OCR_Supplier_Invoice_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $oCR_Supplier_Invoice_Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $oCR_Supplier_Invoice_Reference = null, $version = null)
    {
        $this
            ->setOCR_Supplier_Invoice_Reference($oCR_Supplier_Invoice_Reference)
            ->setVersion($version);
    }
    /**
     * Get OCR_Supplier_Invoice_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getOCR_Supplier_Invoice_Reference()
    {
        return $this->OCR_Supplier_Invoice_Reference;
    }
    /**
     * Set OCR_Supplier_Invoice_Reference value
     * @param \StructType\Unique_IdentifierObjectType $oCR_Supplier_Invoice_Reference
     * @return \StructType\Put_OCR_Supplier_Invoice_ResponseType
     */
    public function setOCR_Supplier_Invoice_Reference(\StructType\Unique_IdentifierObjectType $oCR_Supplier_Invoice_Reference = null)
    {
        $this->OCR_Supplier_Invoice_Reference = $oCR_Supplier_Invoice_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_OCR_Supplier_Invoice_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
