<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Procurement_Conditional_Rule_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Procurement Conditional Rule Response Data.
 * @subpackage Structs
 */
class Put_Procurement_Conditional_Rule_ResponseType extends AbstractStructBase
{
    /**
     * The Procurement_Conditional_Rules_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Procurement Conditional Rule.
     * - minOccurs: 0
     * @var \StructType\Condition_RuleObjectType
     */
    public $Procurement_Conditional_Rules_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Procurement_Conditional_Rule_ResponseType
     * @uses Put_Procurement_Conditional_Rule_ResponseType::setProcurement_Conditional_Rules_Reference()
     * @uses Put_Procurement_Conditional_Rule_ResponseType::setVersion()
     * @param \StructType\Condition_RuleObjectType $procurement_Conditional_Rules_Reference
     * @param string $version
     */
    public function __construct(\StructType\Condition_RuleObjectType $procurement_Conditional_Rules_Reference = null, $version = null)
    {
        $this
            ->setProcurement_Conditional_Rules_Reference($procurement_Conditional_Rules_Reference)
            ->setVersion($version);
    }
    /**
     * Get Procurement_Conditional_Rules_Reference value
     * @return \StructType\Condition_RuleObjectType|null
     */
    public function getProcurement_Conditional_Rules_Reference()
    {
        return $this->Procurement_Conditional_Rules_Reference;
    }
    /**
     * Set Procurement_Conditional_Rules_Reference value
     * @param \StructType\Condition_RuleObjectType $procurement_Conditional_Rules_Reference
     * @return \StructType\Put_Procurement_Conditional_Rule_ResponseType
     */
    public function setProcurement_Conditional_Rules_Reference(\StructType\Condition_RuleObjectType $procurement_Conditional_Rules_Reference = null)
    {
        $this->Procurement_Conditional_Rules_Reference = $procurement_Conditional_Rules_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Procurement_Conditional_Rule_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
