<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Requirements_for_Resource_Plan_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Requirements for Resource Plan Line Request
 * @subpackage Structs
 */
class Put_Requirements_for_Resource_Plan_RequestType extends AbstractStructBase
{
    /**
     * The Resource_Plan_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Resource Requirement
     * - minOccurs: 0
     * @var \StructType\Project_Resource_PlanObjectType
     */
    public $Resource_Plan_Reference;
    /**
     * The Resource_Plan_Requirement_Data
     * Meta information extracted from the WSDL
     * - documentation: Resource Plan Requirement Data
     * - minOccurs: 0
     * @var \StructType\Resource_Plan_Requirement_DataType
     */
    public $Resource_Plan_Requirement_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Requirements_for_Resource_Plan_RequestType
     * @uses Put_Requirements_for_Resource_Plan_RequestType::setResource_Plan_Reference()
     * @uses Put_Requirements_for_Resource_Plan_RequestType::setResource_Plan_Requirement_Data()
     * @uses Put_Requirements_for_Resource_Plan_RequestType::setVersion()
     * @param \StructType\Project_Resource_PlanObjectType $resource_Plan_Reference
     * @param \StructType\Resource_Plan_Requirement_DataType $resource_Plan_Requirement_Data
     * @param string $version
     */
    public function __construct(\StructType\Project_Resource_PlanObjectType $resource_Plan_Reference = null, \StructType\Resource_Plan_Requirement_DataType $resource_Plan_Requirement_Data = null, $version = null)
    {
        $this
            ->setResource_Plan_Reference($resource_Plan_Reference)
            ->setResource_Plan_Requirement_Data($resource_Plan_Requirement_Data)
            ->setVersion($version);
    }
    /**
     * Get Resource_Plan_Reference value
     * @return \StructType\Project_Resource_PlanObjectType|null
     */
    public function getResource_Plan_Reference()
    {
        return $this->Resource_Plan_Reference;
    }
    /**
     * Set Resource_Plan_Reference value
     * @param \StructType\Project_Resource_PlanObjectType $resource_Plan_Reference
     * @return \StructType\Put_Requirements_for_Resource_Plan_RequestType
     */
    public function setResource_Plan_Reference(\StructType\Project_Resource_PlanObjectType $resource_Plan_Reference = null)
    {
        $this->Resource_Plan_Reference = $resource_Plan_Reference;
        return $this;
    }
    /**
     * Get Resource_Plan_Requirement_Data value
     * @return \StructType\Resource_Plan_Requirement_DataType|null
     */
    public function getResource_Plan_Requirement_Data()
    {
        return $this->Resource_Plan_Requirement_Data;
    }
    /**
     * Set Resource_Plan_Requirement_Data value
     * @param \StructType\Resource_Plan_Requirement_DataType $resource_Plan_Requirement_Data
     * @return \StructType\Put_Requirements_for_Resource_Plan_RequestType
     */
    public function setResource_Plan_Requirement_Data(\StructType\Resource_Plan_Requirement_DataType $resource_Plan_Requirement_Data = null)
    {
        $this->Resource_Plan_Requirement_Data = $resource_Plan_Requirement_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Requirements_for_Resource_Plan_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
