<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Supplier_Invoice_History_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: This element is the top-level response element for all "Put" Supplier Invoice History operations.
 * @subpackage Structs
 */
class Put_Supplier_Invoice_History_ResponseType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_History_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the Supplier Invoice History that was added or updated by this web service operation.
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_HistoryObjectType
     */
    public $Supplier_Invoice_History_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Supplier_Invoice_History_ResponseType
     * @uses Put_Supplier_Invoice_History_ResponseType::setSupplier_Invoice_History_Reference()
     * @uses Put_Supplier_Invoice_History_ResponseType::setVersion()
     * @param \StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference
     * @param string $version
     */
    public function __construct(\StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference = null, $version = null)
    {
        $this
            ->setSupplier_Invoice_History_Reference($supplier_Invoice_History_Reference)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Invoice_History_Reference value
     * @return \StructType\Supplier_Invoice_HistoryObjectType|null
     */
    public function getSupplier_Invoice_History_Reference()
    {
        return $this->Supplier_Invoice_History_Reference;
    }
    /**
     * Set Supplier_Invoice_History_Reference value
     * @param \StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference
     * @return \StructType\Put_Supplier_Invoice_History_ResponseType
     */
    public function setSupplier_Invoice_History_Reference(\StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference = null)
    {
        $this->Supplier_Invoice_History_Reference = $supplier_Invoice_History_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Invoice_History_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
