<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element holding data for new supplier invoice work queue tag assignment rule to add.
 * @subpackage Structs
 */
class Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType extends AbstractStructBase
{
    /**
     * The Add_Only
     * Meta information extracted from the WSDL
     * - documentation: Add Only boolean that enforces that instances that only be added, not edited in this web service call.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Add_Only;
    /**
     * The Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference
     * Meta information extracted from the WSDL
     * - documentation: Referenced supplier invoice work queue tag assignment rule.
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType
     */
    public $Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference;
    /**
     * The Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data
     * Meta information extracted from the WSDL
     * - documentation: Data for supplier invoice work queue tag assignment rule to add.
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType
     */
    public $Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for
     * Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType
     * @uses Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType::setAdd_Only()
     * @uses Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType::setSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference()
     * @uses Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType::setSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data()
     * @uses Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType::setVersion()
     * @param bool $add_Only
     * @param \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference
     * @param \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data
     * @param string $version
     */
    public function __construct($add_Only = null, \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference = null, \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data = null, $version = null)
    {
        $this
            ->setAdd_Only($add_Only)
            ->setSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference($supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference)
            ->setSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data($supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data)
            ->setVersion($version);
    }
    /**
     * Get Add_Only value
     * @return bool|null
     */
    public function getAdd_Only()
    {
        return $this->Add_Only;
    }
    /**
     * Set Add_Only value
     * @param bool $add_Only
     * @return \StructType\Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType
     */
    public function setAdd_Only($add_Only = null)
    {
        // validation for constraint: boolean
        if (!is_null($add_Only) && !is_bool($add_Only)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($add_Only, true), gettype($add_Only)), __LINE__);
        }
        $this->Add_Only = $add_Only;
        return $this;
    }
    /**
     * Get Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference value
     * @return \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType|null
     */
    public function getSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference()
    {
        return $this->Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference;
    }
    /**
     * Set Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference value
     * @param \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference
     * @return \StructType\Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType
     */
    public function setSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference(\StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference = null)
    {
        $this->Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference = $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Reference;
        return $this;
    }
    /**
     * Get Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data value
     * @return \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType|null
     */
    public function getSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data()
    {
        return $this->Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data;
    }
    /**
     * Set Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data value
     * @param \StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data
     * @return \StructType\Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType
     */
    public function setSupplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data(\StructType\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data = null)
    {
        $this->Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data = $supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
