<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Reinstate_Asset_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Request on the Reinstate Asset operation.
 * @subpackage Structs
 */
class Reinstate_Asset_RequestType extends AbstractStructBase
{
    /**
     * The Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Financials_Business_Process_ParametersType
     */
    public $Business_Process_Parameters;
    /**
     * The Reinstate_Asset_Data
     * @var \StructType\Reinstate_Asset_WWS_DataType
     */
    public $Reinstate_Asset_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Reinstate_Asset_RequestType
     * @uses Reinstate_Asset_RequestType::setBusiness_Process_Parameters()
     * @uses Reinstate_Asset_RequestType::setReinstate_Asset_Data()
     * @uses Reinstate_Asset_RequestType::setVersion()
     * @param \StructType\Financials_Business_Process_ParametersType $business_Process_Parameters
     * @param \StructType\Reinstate_Asset_WWS_DataType $reinstate_Asset_Data
     * @param string $version
     */
    public function __construct(\StructType\Financials_Business_Process_ParametersType $business_Process_Parameters = null, \StructType\Reinstate_Asset_WWS_DataType $reinstate_Asset_Data = null, $version = null)
    {
        $this
            ->setBusiness_Process_Parameters($business_Process_Parameters)
            ->setReinstate_Asset_Data($reinstate_Asset_Data)
            ->setVersion($version);
    }
    /**
     * Get Business_Process_Parameters value
     * @return \StructType\Financials_Business_Process_ParametersType|null
     */
    public function getBusiness_Process_Parameters()
    {
        return $this->Business_Process_Parameters;
    }
    /**
     * Set Business_Process_Parameters value
     * @param \StructType\Financials_Business_Process_ParametersType $business_Process_Parameters
     * @return \StructType\Reinstate_Asset_RequestType
     */
    public function setBusiness_Process_Parameters(\StructType\Financials_Business_Process_ParametersType $business_Process_Parameters = null)
    {
        $this->Business_Process_Parameters = $business_Process_Parameters;
        return $this;
    }
    /**
     * Get Reinstate_Asset_Data value
     * @return \StructType\Reinstate_Asset_WWS_DataType|null
     */
    public function getReinstate_Asset_Data()
    {
        return $this->Reinstate_Asset_Data;
    }
    /**
     * Set Reinstate_Asset_Data value
     * @param \StructType\Reinstate_Asset_WWS_DataType $reinstate_Asset_Data
     * @return \StructType\Reinstate_Asset_RequestType
     */
    public function setReinstate_Asset_Data(\StructType\Reinstate_Asset_WWS_DataType $reinstate_Asset_Data = null)
    {
        $this->Reinstate_Asset_Data = $reinstate_Asset_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Reinstate_Asset_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
