<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Remove_Supplier_Contract_Line_Hold_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Supplier Contract Reference and Lines which are being taken off Hold.
 * @subpackage Structs
 */
class Remove_Supplier_Contract_Line_Hold_RequestType extends AbstractStructBase
{
    /**
     * The Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - documentation: Business Process Parameters provide the ability to auto-submit to the business process.
     * - minOccurs: 0
     * @var \StructType\Financials_Business_Process_ParametersType
     */
    public $Business_Process_Parameters;
    /**
     * The Remove_Supplier_Contract_Line_Hold_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Remove_Supplier_Contract_Line_Hold_DataType
     */
    public $Remove_Supplier_Contract_Line_Hold_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Remove_Supplier_Contract_Line_Hold_RequestType
     * @uses Remove_Supplier_Contract_Line_Hold_RequestType::setBusiness_Process_Parameters()
     * @uses Remove_Supplier_Contract_Line_Hold_RequestType::setRemove_Supplier_Contract_Line_Hold_Data()
     * @uses Remove_Supplier_Contract_Line_Hold_RequestType::setVersion()
     * @param \StructType\Financials_Business_Process_ParametersType $business_Process_Parameters
     * @param \StructType\Remove_Supplier_Contract_Line_Hold_DataType $remove_Supplier_Contract_Line_Hold_Data
     * @param string $version
     */
    public function __construct(\StructType\Financials_Business_Process_ParametersType $business_Process_Parameters = null, \StructType\Remove_Supplier_Contract_Line_Hold_DataType $remove_Supplier_Contract_Line_Hold_Data = null, $version = null)
    {
        $this
            ->setBusiness_Process_Parameters($business_Process_Parameters)
            ->setRemove_Supplier_Contract_Line_Hold_Data($remove_Supplier_Contract_Line_Hold_Data)
            ->setVersion($version);
    }
    /**
     * Get Business_Process_Parameters value
     * @return \StructType\Financials_Business_Process_ParametersType|null
     */
    public function getBusiness_Process_Parameters()
    {
        return $this->Business_Process_Parameters;
    }
    /**
     * Set Business_Process_Parameters value
     * @param \StructType\Financials_Business_Process_ParametersType $business_Process_Parameters
     * @return \StructType\Remove_Supplier_Contract_Line_Hold_RequestType
     */
    public function setBusiness_Process_Parameters(\StructType\Financials_Business_Process_ParametersType $business_Process_Parameters = null)
    {
        $this->Business_Process_Parameters = $business_Process_Parameters;
        return $this;
    }
    /**
     * Get Remove_Supplier_Contract_Line_Hold_Data value
     * @return \StructType\Remove_Supplier_Contract_Line_Hold_DataType|null
     */
    public function getRemove_Supplier_Contract_Line_Hold_Data()
    {
        return $this->Remove_Supplier_Contract_Line_Hold_Data;
    }
    /**
     * Set Remove_Supplier_Contract_Line_Hold_Data value
     * @param \StructType\Remove_Supplier_Contract_Line_Hold_DataType $remove_Supplier_Contract_Line_Hold_Data
     * @return \StructType\Remove_Supplier_Contract_Line_Hold_RequestType
     */
    public function setRemove_Supplier_Contract_Line_Hold_Data(\StructType\Remove_Supplier_Contract_Line_Hold_DataType $remove_Supplier_Contract_Line_Hold_Data = null)
    {
        $this->Remove_Supplier_Contract_Line_Hold_Data = $remove_Supplier_Contract_Line_Hold_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Remove_Supplier_Contract_Line_Hold_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
