<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Requisition_Additional_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper element containing the Requisition additional data for requested references or criteria, and for requested response group.
 * @subpackage Structs
 */
class Requisition_Additional_DataType extends AbstractStructBase
{
    /**
     * The Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Requisition reference
     * - minOccurs: 0
     * @var \StructType\RequisitionObjectType
     */
    public $Requisition_Reference;
    /**
     * The Business_Object_Additional_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Non_Effective_Dated_Web_Service_Additional_DataType
     */
    public $Business_Object_Additional_Data;
    /**
     * Constructor method for Requisition_Additional_DataType
     * @uses Requisition_Additional_DataType::setRequisition_Reference()
     * @uses Requisition_Additional_DataType::setBusiness_Object_Additional_Data()
     * @param \StructType\RequisitionObjectType $requisition_Reference
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     */
    public function __construct(\StructType\RequisitionObjectType $requisition_Reference = null, \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this
            ->setRequisition_Reference($requisition_Reference)
            ->setBusiness_Object_Additional_Data($business_Object_Additional_Data);
    }
    /**
     * Get Requisition_Reference value
     * @return \StructType\RequisitionObjectType|null
     */
    public function getRequisition_Reference()
    {
        return $this->Requisition_Reference;
    }
    /**
     * Set Requisition_Reference value
     * @param \StructType\RequisitionObjectType $requisition_Reference
     * @return \StructType\Requisition_Additional_DataType
     */
    public function setRequisition_Reference(\StructType\RequisitionObjectType $requisition_Reference = null)
    {
        $this->Requisition_Reference = $requisition_Reference;
        return $this;
    }
    /**
     * Get Business_Object_Additional_Data value
     * @return \StructType\Non_Effective_Dated_Web_Service_Additional_DataType|null
     */
    public function getBusiness_Object_Additional_Data()
    {
        return $this->Business_Object_Additional_Data;
    }
    /**
     * Set Business_Object_Additional_Data value
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     * @return \StructType\Requisition_Additional_DataType
     */
    public function setBusiness_Object_Additional_Data(\StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this->Business_Object_Additional_Data = $business_Object_Additional_Data;
        return $this;
    }
}
