<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Mass_Reopen_Procurement_Documents_RequestType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Mass Reopen Procurement Documents reference for submit and all Mass Reopen Procurement Documents data items.
 * @subpackage Structs
 */
class Submit_Mass_Reopen_Procurement_Documents_RequestType extends AbstractStructBase
{
    /**
     * The Reopen_Procurement_Documents_Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: Mass Reopen Procurement Documents Reference
     * - minOccurs: 0
     * @var \StructType\Reopen_Procurement_Documents_EventObjectType
     */
    public $Reopen_Procurement_Documents_Event_Reference;
    /**
     * The Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - documentation: Business Process Parameters provide the ability to auto-complete the business process.
     * - minOccurs: 0
     * @var \StructType\Financials_Business_Process_ParametersType
     */
    public $Business_Process_Parameters;
    /**
     * The Mass_Reopen_Procurement_Documents_Data
     * Meta information extracted from the WSDL
     * - documentation: Mass Reopen Procurement Documents Data
     * - minOccurs: 0
     * @var \StructType\Mass_Reopen_Procurement_Documents_DataType
     */
    public $Mass_Reopen_Procurement_Documents_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Mass_Reopen_Procurement_Documents_RequestType
     * @uses Submit_Mass_Reopen_Procurement_Documents_RequestType::setReopen_Procurement_Documents_Event_Reference()
     * @uses Submit_Mass_Reopen_Procurement_Documents_RequestType::setBusiness_Process_Parameters()
     * @uses Submit_Mass_Reopen_Procurement_Documents_RequestType::setMass_Reopen_Procurement_Documents_Data()
     * @uses Submit_Mass_Reopen_Procurement_Documents_RequestType::setVersion()
     * @param \StructType\Reopen_Procurement_Documents_EventObjectType $reopen_Procurement_Documents_Event_Reference
     * @param \StructType\Financials_Business_Process_ParametersType $business_Process_Parameters
     * @param \StructType\Mass_Reopen_Procurement_Documents_DataType $mass_Reopen_Procurement_Documents_Data
     * @param string $version
     */
    public function __construct(\StructType\Reopen_Procurement_Documents_EventObjectType $reopen_Procurement_Documents_Event_Reference = null, \StructType\Financials_Business_Process_ParametersType $business_Process_Parameters = null, \StructType\Mass_Reopen_Procurement_Documents_DataType $mass_Reopen_Procurement_Documents_Data = null, $version = null)
    {
        $this
            ->setReopen_Procurement_Documents_Event_Reference($reopen_Procurement_Documents_Event_Reference)
            ->setBusiness_Process_Parameters($business_Process_Parameters)
            ->setMass_Reopen_Procurement_Documents_Data($mass_Reopen_Procurement_Documents_Data)
            ->setVersion($version);
    }
    /**
     * Get Reopen_Procurement_Documents_Event_Reference value
     * @return \StructType\Reopen_Procurement_Documents_EventObjectType|null
     */
    public function getReopen_Procurement_Documents_Event_Reference()
    {
        return $this->Reopen_Procurement_Documents_Event_Reference;
    }
    /**
     * Set Reopen_Procurement_Documents_Event_Reference value
     * @param \StructType\Reopen_Procurement_Documents_EventObjectType $reopen_Procurement_Documents_Event_Reference
     * @return \StructType\Submit_Mass_Reopen_Procurement_Documents_RequestType
     */
    public function setReopen_Procurement_Documents_Event_Reference(\StructType\Reopen_Procurement_Documents_EventObjectType $reopen_Procurement_Documents_Event_Reference = null)
    {
        $this->Reopen_Procurement_Documents_Event_Reference = $reopen_Procurement_Documents_Event_Reference;
        return $this;
    }
    /**
     * Get Business_Process_Parameters value
     * @return \StructType\Financials_Business_Process_ParametersType|null
     */
    public function getBusiness_Process_Parameters()
    {
        return $this->Business_Process_Parameters;
    }
    /**
     * Set Business_Process_Parameters value
     * @param \StructType\Financials_Business_Process_ParametersType $business_Process_Parameters
     * @return \StructType\Submit_Mass_Reopen_Procurement_Documents_RequestType
     */
    public function setBusiness_Process_Parameters(\StructType\Financials_Business_Process_ParametersType $business_Process_Parameters = null)
    {
        $this->Business_Process_Parameters = $business_Process_Parameters;
        return $this;
    }
    /**
     * Get Mass_Reopen_Procurement_Documents_Data value
     * @return \StructType\Mass_Reopen_Procurement_Documents_DataType|null
     */
    public function getMass_Reopen_Procurement_Documents_Data()
    {
        return $this->Mass_Reopen_Procurement_Documents_Data;
    }
    /**
     * Set Mass_Reopen_Procurement_Documents_Data value
     * @param \StructType\Mass_Reopen_Procurement_Documents_DataType $mass_Reopen_Procurement_Documents_Data
     * @return \StructType\Submit_Mass_Reopen_Procurement_Documents_RequestType
     */
    public function setMass_Reopen_Procurement_Documents_Data(\StructType\Mass_Reopen_Procurement_Documents_DataType $mass_Reopen_Procurement_Documents_Data = null)
    {
        $this->Mass_Reopen_Procurement_Documents_Data = $mass_Reopen_Procurement_Documents_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Mass_Reopen_Procurement_Documents_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
