<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Receipt_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Receipt Reference
 * @subpackage Structs
 */
class Submit_Receipt_ResponseType extends AbstractStructBase
{
    /**
     * The Receipt_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to Submitted Receipt
     * - minOccurs: 0
     * @var \StructType\ReceiptObjectType
     */
    public $Receipt_Reference;
    /**
     * The Exceptions_Response_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Application_Instance_Related_Exceptions_DataType
     */
    public $Exceptions_Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Receipt_ResponseType
     * @uses Submit_Receipt_ResponseType::setReceipt_Reference()
     * @uses Submit_Receipt_ResponseType::setExceptions_Response_Data()
     * @uses Submit_Receipt_ResponseType::setVersion()
     * @param \StructType\ReceiptObjectType $receipt_Reference
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @param string $version
     */
    public function __construct(\StructType\ReceiptObjectType $receipt_Reference = null, \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null, $version = null)
    {
        $this
            ->setReceipt_Reference($receipt_Reference)
            ->setExceptions_Response_Data($exceptions_Response_Data)
            ->setVersion($version);
    }
    /**
     * Get Receipt_Reference value
     * @return \StructType\ReceiptObjectType|null
     */
    public function getReceipt_Reference()
    {
        return $this->Receipt_Reference;
    }
    /**
     * Set Receipt_Reference value
     * @param \StructType\ReceiptObjectType $receipt_Reference
     * @return \StructType\Submit_Receipt_ResponseType
     */
    public function setReceipt_Reference(\StructType\ReceiptObjectType $receipt_Reference = null)
    {
        $this->Receipt_Reference = $receipt_Reference;
        return $this;
    }
    /**
     * Get Exceptions_Response_Data value
     * @return \StructType\Application_Instance_Related_Exceptions_DataType|null
     */
    public function getExceptions_Response_Data()
    {
        return $this->Exceptions_Response_Data;
    }
    /**
     * Set Exceptions_Response_Data value
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @return \StructType\Submit_Receipt_ResponseType
     */
    public function setExceptions_Response_Data(\StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null)
    {
        $this->Exceptions_Response_Data = $exceptions_Response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Receipt_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
