<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Request_for_Quote_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Submit Request for Quote Response.
 * @subpackage Structs
 */
class Submit_Request_for_Quote_ResponseType extends AbstractStructBase
{
    /**
     * The Request_for_Quote_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Request for Quote.
     * - minOccurs: 0
     * @var \StructType\Request_for_QuoteObjectType
     */
    public $Request_for_Quote_Reference;
    /**
     * The Exceptions_Response_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Application_Instance_Related_Exceptions_DataType
     */
    public $Exceptions_Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Request_for_Quote_ResponseType
     * @uses Submit_Request_for_Quote_ResponseType::setRequest_for_Quote_Reference()
     * @uses Submit_Request_for_Quote_ResponseType::setExceptions_Response_Data()
     * @uses Submit_Request_for_Quote_ResponseType::setVersion()
     * @param \StructType\Request_for_QuoteObjectType $request_for_Quote_Reference
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @param string $version
     */
    public function __construct(\StructType\Request_for_QuoteObjectType $request_for_Quote_Reference = null, \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null, $version = null)
    {
        $this
            ->setRequest_for_Quote_Reference($request_for_Quote_Reference)
            ->setExceptions_Response_Data($exceptions_Response_Data)
            ->setVersion($version);
    }
    /**
     * Get Request_for_Quote_Reference value
     * @return \StructType\Request_for_QuoteObjectType|null
     */
    public function getRequest_for_Quote_Reference()
    {
        return $this->Request_for_Quote_Reference;
    }
    /**
     * Set Request_for_Quote_Reference value
     * @param \StructType\Request_for_QuoteObjectType $request_for_Quote_Reference
     * @return \StructType\Submit_Request_for_Quote_ResponseType
     */
    public function setRequest_for_Quote_Reference(\StructType\Request_for_QuoteObjectType $request_for_Quote_Reference = null)
    {
        $this->Request_for_Quote_Reference = $request_for_Quote_Reference;
        return $this;
    }
    /**
     * Get Exceptions_Response_Data value
     * @return \StructType\Application_Instance_Related_Exceptions_DataType|null
     */
    public function getExceptions_Response_Data()
    {
        return $this->Exceptions_Response_Data;
    }
    /**
     * Set Exceptions_Response_Data value
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @return \StructType\Submit_Request_for_Quote_ResponseType
     */
    public function setExceptions_Response_Data(\StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null)
    {
        $this->Exceptions_Response_Data = $exceptions_Response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Request_for_Quote_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
